﻿/*! Auto-TOC script functions for HM Premium Pack Version 4.3.0
Copyright (c) 2015-2021 by Tim Green 
All rights reserved. */

// Are we in a search results page?

// Check if the current page is a Webhelp or CHM search results topic
function SearchCheck() 
{
  var foundHilite = window.location.search.lastIndexOf("zoom_highlight") > 0;
  if (!foundHilite) {
    var fontTags = document.getElementsByTagName("FONT");
    if (fontTags.length > 0) {
      var hStyle = "";
      for (var cCheck = 0; cCheck < fontTags.length; cCheck++) {
        hStyle = fontTags[cCheck].style.cssText;
        if (hStyle.indexOf("BACKGROUND-COLOR") == 0) {
	  foundHilite = true;
          break; 
        }
      }
    }
  }  return foundHilite;     
}

// String fix functions
function truncate(str, limit) {
var bits, i;
    if (limit == 0) return str;
    if ((limit > 0) && (limit <= 20)) limit = 20;
	bits = str.split('');
	if (bits.length > limit) {
	   for (i = bits.length - 1; i > -1; --i) {
		if (i > limit) {
		bits.length = i;
		}
		else if (' ' === bits[i]) {
		bits.length = i;
		break;
		}
	}
	bits.push('...');
	}
return bits.join('');

}
function trim(s) {
	return s.replace(/^\s+|\s+$/g, "");
}

function htmlFix(hd) {
	heading = hd.replace(/\&/g, "&amp;");
	hd = hd.replace(/</g, "&lt;");
	hd = hd.replace(/>/g, "&gt;");
	return hd;
	}

function autoTOC() {

var topicParas = new Array();
var tocHeads = new Array();

// Get config variables
/* if (!window.opener) { var atocVars = parent.window.hmatocvars; } else {
	var atocVars = window.opener.hmatocvars;} */

var atoc_tip = hmatocvars.atoc_tip;
var atoc_minHeaders = hmatocvars.atoc_minHeaders;
var atoc_btntip_on = hmatocvars.atoc_btntip_on;
var atoc_toptip =  hmatocvars.atoc_toptip;
var atoc_top = hmatocvars.atoc_top;
var atoc_bg = hmatocvars.atoc_bg;
var atoc_border = hmatocvars.atoc_border;
var atoc_linkcolor = hmatocvars.atoc_linkcolor;
var atoc_linklimit = hmatocvars.atoc_linklimit;
var atoc_hovercolor = hmatocvars.atoc_hovercolor;
var atoc_hoverbgcolor = hmatocvars.atoc_hoverbgcolor;

var thisPara,
	linkText,
	thisParaClass,
	subStyle,
	fullLinkText,
	linkID,
	TOClink,
	autoTOCcontent,
	TOCbox,
	isATOC = false;

// Initialize ATOC tool

$("div#atocIcon").on("mouseover", function() {
	$("img#hmAtocLink").addClass("naviconH");
	}).on("mouseout", function() {
	$("img#hmAtocLink").removeClass("naviconH")
	});
$("img#hmAtocLink").attr({"src": "contents.png", "title": atoc_btntip_on, "alt": atoc_btntip_on});
$("div#atocIcon, div#atocIcon span").css("color","#000");

// Tag toggle headers with icons with temporary classes for ATOC
// ":not" clause prevents doubling up when searching with the highlighter
// which re-runs the autoTOC() function

  $("span[class*='_atoc_']").parent("td:not(:has(span[class='temp_atoc_']))").each(function(){
   		var tempTogHead = $(this).html();
   		tempTogHead = '<span class="temp_atoc_">' + tempTogHead + '</span>';
   		$(this).html(tempTogHead);
   		// alert($(this).html());
   		}); 
	
    $("span[class*='_atocs_']").parent("td:not(:has(span[class='temp_atocs_']))").each(function(){
	// $("td:not(:has(span[class='temp_atocs_']))").has("span[class*='_atocs_']").each(function(){
   		var tempTogHead = $(this).html();
   		tempTogHead = '<span class="temp_atocs_">' + tempTogHead + '</span>';
   		$(this).html(tempTogHead);
   		// alert($(this).html());
   		});

	// Get the headers with AutoTOC tags
	topicParas = $("[class*='_atoc_'],[class*='_atocs_']").filter("[class^='p_']").add("span[class='temp_atoc_'],span[class='temp_atocs_']");
	// alert(topicParas.length);
	
	if (topicParas.length >= atoc_minHeaders) {
	for (var i = 0; i < topicParas.length;i++) {
		thisPara = topicParas[i];
		linkText = $(topicParas[i]).text();
		linkText = trim(linkText);
		linkText = htmlFix(linkText);
		thisParaClass = $(thisPara).attr("class");
		subStyle = (thisParaClass.indexOf("_atocs_") != -1);
		// Delete non-breaking space for brain-dead IE
		if (linkText.length == 1) linkText = linkText.replace(/\xa0/,"");
		if (linkText != "") {
			isATOC = true;
			linkID = "autoTOC"+i;
			fullLinkText = linkText.replace(/\"/g,"'");
			linkText = truncate(linkText,atoc_linklimit);
			thisPara.innerHTML = '<a id="'+linkID+'"></a>' + thisPara.innerHTML;
			if (!subStyle) {
			   TOClink = '<li class="autoTOC" id="src_'+linkID+'" title="'+atoc_tip+fullLinkText+'"><p class="autoTOC" style="color:'+atoc_linkcolor+';"><img src="atoc_bullet.png" class="menuicon" alt="'+atoc_tip+fullLinkText+'" border="0" />&nbsp;'+linkText+'</p></li>';
				} else {
			   TOClink = '<li class="autoTOC" id="src_'+linkID+'" title="'+atoc_tip+fullLinkText+'"><p class="autoTOC" style="font-size: 90%; font-weight: normal;color:'+atoc_linkcolor+';">&nbsp;&nbsp;<img src="atoc_bullet.png" class="menuicon" alt="'+atoc_tip+fullLinkText+'" border="0" />&nbsp;'+linkText+'</p></li>';
				}
				tocHeads.push(TOClink);
				}
	}

		} else return;

	// Build the AutoTOC if elements exist

	if ((tocHeads[0]) && (tocHeads[0] != "")) {
	autoTOCcontent = "";
	TOCbox = document.getElementById("autoTocWrapper");
	for (var i = 0; i < tocHeads.length;i++) {
		autoTOCcontent = autoTOCcontent + tocHeads[i];
		}
	autoTOCcontent = '<li id="toplink" title="'+atoc_toptip+'"><p class="autoTOC"><img src="atoc_gotop.png" class="menuicon" alt="'+atoc_toptip+'" border="0" />&nbsp;'+atoc_top+'</p></li>' +autoTOCcontent;
	autoTOCcontent = '<div id="autoTocMiddle"><div id="autoTocInner"><ul>' + autoTOCcontent + '</ul></div></div>';

	TOCbox.innerHTML = autoTOCcontent;
	} // End Build ATOC


	// Initialize the jQuery functions
// 	$(document).ready(function() {

		// Function for getting tagnames
		$.fn.tagName = function() {
    	return this.get(0).tagName;
		}
		
	// Reposition ATOC menu

	  function atocPos() {
		var headerPos = $("div#hmheader").outerHeight();
		if (!parent.window.hmWebHelp && window.opener) {
			$("div#autoTocWrapper").css("right", "25px");
			} 
		if (!parent.window.hmWebHelp && !window.opener) {
			$("div#autoTocWrapper").css("right", "30px");
			}
     	 $("div#autoTocWrapper").css("top", headerPos + "px");
	  }

	// Show/hide ATOC navicon_contents
     $("div#atocIcon").on("click", function(event) {
	 event.stopPropagation();
	
	 $(window).on('resize.atocResize', function() {
	   atocPos();
		});

		if ($("div#autoTocWrapper").is(":hidden")) {
			atocPos();
			$("div#autoTocWrapper").slideDown("fast");
			$("div#unclicker").show();
			
		$("div#hmheader").on("mousedown", function() {
		 if ($("div#autoTocWrapper").is(":visible")) {
		 $("#autoTocWrapper").slideUp("fast");
		 $(window).off('resize.atocResize');
		 $(this).css("cursor","");
		 $(this).off("mousedown");
		 }
		 }).css("cursor","default");
			
			} else {
			$("div#autoTocWrapper").slideUp("fast");
			$(window).off('resize.atocResize');
			$("div#unclicker").hide();
			$("div#hmheader").off("click").css("cursor","");
			} 
     }).css("cursor","pointer");

    // Jump to targets for main ATOC entries
     $("li.autoTOC").click(function () {

     	var isSearch = SearchCheck();
     	var cTarget = $(this).attr("id");
    	var tTarget = cTarget.replace(/src_/,"");
        var theTarget = $("a[id='"+tTarget+"']");

   // If there are toggles on the page close them all
   if ((HMToggles.length != null) && (!isSearch)) {
   HMToggleExpandAll(false); 
   }

   // Scroll to the target
   aniScroll(theTarget,"menu",false);

    return false;
    });

    // Scroll to top of document function
	$("#toplink").click(function () {
    var isSearch = SearchCheck();
	if (HMToggles.length != null && !isSearch) HMToggleExpandAll(false);
	var sTarget = "div#idcontent";
	$(sTarget).scrollTo(0, 600);
	return false;
	});

   	  // Close ATOC function
 		$("div#unclicker").on("mousedown", function(event) {
		event.stopPropagation();
		$("#autoTocWrapper").slideUp("fast");
		$("div#hmheader").css("cursor","");
		$(this).hide();
		});

	// Menu highlight in ATOC

	$("#autoTocWrapper ul li").mouseover(function(){
		$(this).css("backgroundColor", atoc_hoverbgcolor);
		$(this).children().filter("p.autoTOC").css("color", atoc_hovercolor);
		});
	$("#autoTocWrapper ul li").mouseout(function(){
		$(this).css("backgroundColor", atoc_bg);
		$(this).children().filter("p.autoTOC").css("color", atoc_linkcolor);
		});
	} // autoTOC function
var atocLoaded = true;
