﻿/*! Topic page init functions for HM Premium Pack Version 4.3.0
Copyright (c) 2015-2021 by Tim Green 
All rights reserved. */

//Header init
(function(){
	 if (!(self!=top && window.parent.window.hmWebHelp)) return;
	 
	 // Don't rewrite description or keywords of main page on first help load
	 window.parent.window.hmnavpages.loadCount++;
	 if (window.parent.window.hmnavpages.loadCount > 1) {
		$("meta[name='description']",window.parent.document).remove();
		$("head",window.parent.document).prepend("<meta name=\"description\" content=\""+tVars.descr+"\" />");
		$("meta[name='keywords']",window.parent.document).remove();
		$("head",window.parent.document).prepend("<meta name=\"keywords\" content=\""+tVars.keys+"\" />");
	 }
		
		if (tVars.topicTitleBar) {
		
		var tTitle = tVars.titleP;
		
		switch (tVars.titleBarContent)  {
			
			case "project":
			tTitle = tVars.projectTitle + " - " + tVars.titleP;
			break;
			case "parent":
				tTitle = tVars.mailpath.substr(0,tVars.mailpath.length-2);
				var levels = 0;
				try {levels = tTitle.match(/&gt;/ig).length;} catch(err) { levels = 0;}
				if (levels > 1) {
					var tNew = tTitle.substr(tTitle.lastIndexOf("&gt;"));
					tTitle = tTitle.substr(0,tTitle.lastIndexOf("&gt;"));
					tNew = tTitle.substr(tTitle.lastIndexOf("&gt;")+4) + " " + tNew;
					tTitle = tNew;
					}
				break;
			default:
			break;
			
			}
		tTitle = "<title>" + tTitle + "</title>";
		$("title",window.parent.document).remove();
		$("head",window.parent.document).prepend(tTitle);
		}
		
		// Rewrite the Address: bar for browsers that support HTML5 history
		if (history && history.pushState) {
			var newState = tVars.hmHelpPage + "?" + tVars.currP + document.location.hash;
			window.parent.window.history.replaceState(null,null,newState);
			// Close any open lightbox in the parent
			parent.hmWebHelp.closeLightBox();
			}
})();



// Monkey patches for standard HM functions

// Add sync delay on first topic load for brain-dead IE
// Prevent syncing when multiple tabs are being loaded
HMSyncTOCold = HMSyncTOC;
HMSyncTOC = function(indexPageUrl, selfUrl) {

	// Don't sync if multiple tabs are being loaded automatically
	try {var Parent = parent.window.hmWebHelp;} catch(err) { var Parent = false; }
	if (Parent) {
	if (parent.hmWebHelp.autoTabs) return;
	} 
	
	// Extract Zoom search highlight from URLs from external search pages if found
	var zoomHilite = "";
	var zoomrx = /(zoom_highlight(?:sub)?=.+)&|(zoom_highlight(?:sub)?=.+?)$/im;
	var match = zoomrx.exec(document.location.search);
	if (match != null) {
	zoomHilite = typeof match[1] != "undefined" ? "\&" + match[1] : "\&" + match[2];
	selfUrl += zoomHilite;
	}
	
	Parent = parent.window.hmWebHelp ? parent.window.hmWebHelp.hmTopicLoaded : window.opener && window.opener.hmWebHelp ? window.opener.hmWebHelp.hmTopicLoaded : false;
	Parent = (Parent && (document.all && !window.opera));
	if (Parent) 
		HMSyncTOCold(indexPageUrl, selfUrl); else {
	setTimeout(function() {
	HMSyncTOCold(indexPageUrl, selfUrl);
	},200);
	}
};

// Load an external script (alternative to Ajax for some scripts)
function loadScript(scriptfile, mode){
 if (mode=="js"){ 
  var ref=document.createElement('script');
  ref.setAttribute("type","text/javascript");
  ref.setAttribute("src", scriptfile);
 }
 else if (mode=="css"){ 
  var ref=document.createElement("link");
  ref.setAttribute("rel", "stylesheet");
  ref.setAttribute("type", "text/css");
  ref.setAttribute("href", scriptfile);
 }
 if (typeof ref!="undefined") {
  document.getElementsByTagName("head")[0].appendChild(ref);
  }
}

// Dynamically add CSS before DOM for visually smooth init
function addCss(cssCode) {
var styleElement = document.createElement("style");
  styleElement.type = "text/css";
  if (styleElement.styleSheet) {
    styleElement.styleSheet.cssText = cssCode;
  } else {
    styleElement.appendChild(document.createTextNode(cssCode));
  }
  document.getElementsByTagName("head")[0].appendChild(styleElement);
}

// Set page IDs in parent for main tab
if (parent.window.hmWebHelp) {
	if (!parent.window.hmWebHelp.isNewTab) {
		parent.window.hmWebHelp.currentPage = parent.window.hmWebHelp.activePage = window.tVars.currP;
		}
	}

// Initialize noJS elements
hmatocvars.atoc_css = "";
// ATOC menu
if (hmatocvars.atoc_show) {
	hmatocvars.atoc_css = 'div#atocIcon {display: block; visibility: hidden;}'+
	'\np.autoTOC {color:'+hmatocvars.atoc_linkcolor+';}\n' +
	'\n#autoTocWrapper ul li {background-color:'+hmatocvars.atoc_bg+';}' +
	'\n#autoTocWrapper,#autoTocInner {border-color:'+hmatocvars.atoc_border+'}';
	}

if (document.location.search.indexOf("toc=0") > -1 && !window.opener) {
 hmatocvars.atoc_css += '\ndiv#hmheader {padding: 10px 0px 0 10px; width: auto}' + 
	'\ndiv#idcontent {padding: 10px 10px 10px 10px; overflow-x: auto; overflow-y: scroll; position: absolute;' +
    '\nright: 0px; bottom: 0px; left: 0px;}\n';
 }

if (document.all && !window.opera && hmatocvars.atoc_show) {
	hmatocvars.atoc_css += 'div#atocIcon {right: 20px;}';
	}

if (tVars.header) {
	var pageVis = "";
	if (parent.window && parent.window.hmnavpages) {
		pageVis = "; visibility: hidden;";
	}
	
	addCss('html,body {overflow: hidden;}\n' +
	'div#hmheader {position: fixed; overflow: hidden; }\n' +
'div#idcontent {position: absolute; overflow-x: auto; overflow-y: scroll;'+pageVis+'}\n' +
	'#noScriptNavHead {display: none;}\n' + hmatocvars.atoc_css);
	} else {
	addCss('html,body {overflow: hidden;}\n' +
	'div#hmheader {display: none; }\n' +
'div#idcontent {position: absolute; top: 0px; overflow-x: auto; overflow-y: scroll;'+pageVis+'}\n' +
	'#noScriptNavHead {display: none;}\n');
	}

// Cookie functions

var cookiesEnabled = (function() {
	var cookieEnabled = (navigator.cookieEnabled) ? true : false;
	if (typeof navigator.cookieEnabled == "undefined" && !cookieEnabled){ 
	document.cookie="testcookie";
	cookieEnabled = (document.cookie.indexOf("testcookie") != -1) ? true : false;
	}
	return (cookieEnabled);
	})();

// Cookie functions
var doCookies = {
	setCookie: function(name,value,timebase,time) {
		if (timebase && typeof(time) === "number") {
		switch(timebase) {
			case "seconds":
			time = time * 1000;
			break;
			case "minutes":
			time = time * 1000 * 60;
			break;
			case "hours":
			time = time * 1000 * 60 * 60;
			break;
			case "days":
			time = time * 1000 * 60 * 60 * 24;
			break;
			// Default is days
			default:
			time = time * 1000 * 60 * 60 * 24;
			}
		}
		if (time) {
			var date = new Date();
			date.setTime(date.getTime()+(time));
			var expires = "; expires="+date.toGMTString();
		}
		// 0 or null makes a session cookie
		else var expires = "";
		document.cookie = name+"="+value+expires+"; path=/";
		}, // setCookie
	getCookie: function(name) {
		var nameEQ = name + "=";
		var ca = document.cookie.split(';');
		for(var i=0;i < ca.length;i++) {
			var c = ca[i];
			while (c.charAt(0)==' ') c = c.substring(1,c.length);
			if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
		}
		return null;
	},
	deleteCookie: function(name) {
		this.setCookie(name,"","days",-1);
	}
};

// Session variables
var sessionVariable = {
		
		localS: Storage && localStorage && sessionStorage,
		
		compilehash: parent.window.hminfo && typeof(parent.window.hminfo.compilehash) !== "undefined" ? parent.window.hminfo.compilehash : tVars.compilehash,
		
		setPV: function(sVar,sVal) {
			if (this.localS) {
				localStorage.setItem(this.compilehash + sVar,sVal);
			} else
				doCookies.setCookie(this.compilehash + sVar,sVal,"days",365);	
		},
		setSV: function(sVar,sVal) {
			if (this.localS)
				sessionStorage.setItem(this.compilehash + sVar,sVal);
			else
				doCookies.setCookie(this.compilehash + sVar,sVal,"minutes",false);
		},
		getPV: function(sVar) {
			if (this.localS) {
				if (typeof(localStorage.getItem(this.compilehash + sVar)) !== "undefined")
					return localStorage.getItem(this.compilehash + sVar);
				else return null;
			} else 
				return doCookies.getCookie(this.compilehash + sVar);
		},
		getSV: function(sVar) {
			if (this.localS) {
				if (typeof(sessionStorage.getItem(this.compilehash + sVar)) !== "undefined")
					return sessionStorage.getItem(this.compilehash + sVar);
				else return null;
			} else 
				return doCookies.getCookie(this.compilehash + sVar);
		},
		deletePV: function(sVar) {
			if (this.localS)
				localStorage.removeItem(this.compilehash + sVar);
			else
				doCookies.deleteCookie(this.compilehash + sVar);
				
		},
		deleteSV: function(sVar) {
			if (this.localS)
				sessionStorage.removeItem(this.compilehash + sVar);
			else
				doCookies.deleteCookie(this.compilehash + sVar);
				
		}
	};


/* ToggleJump Functions */
// Open all toggles around a target if present
	function toggleCheck(target) {
	    // Array of closed toggles above target point
		var tParents = $(target).parents("div[id^='TOGGLE'][hm\\.state='0']");
		if (tParents.length > 0) {
		// Open the parent toggles from the top down
		for (var i=tParents.length-1;i>-1;i--) {
				var t1 = $(tParents[i]).attr("id");
				var t2 = t1 + "_ICON";
				// Check whether matching icon exists
				if ($("img[id='"+t2+"']").length > 0) {
					HMToggle('expand',t1,t2);
					} else {
					HMToggle('expand',t1);
					}
			}
		// Return pause value for timer
		return tParents.length * 200;
		} else {
		return 0;
		}
	} // toggleCheck();
	

// Format printable version 
function doPrint() {	 
	tVars.printMode = true;
 	$("body").css("visibility","hidden");
		setTimeout(function() {
			var temp = hmAnimate;
			var manPrintButton = tVars.autoPrint ? "" : '<button onclick="print();window.close();" id="livePrintButton" title="'+tVars.printButtonTip+'"><img id="livePrintIcon" src="printer.png" />&nbsp;'+tVars.printButton+'</button>';
			if (temp) hmAnimate = false;
			 HMToggleExpandAll(true);
			 $("div#hmheadercontents img, p#breadcrumbs, div#atocIcon, div#autoTocWrapper, ul#topictabs").remove();
			 if (!tVars.printFooter) {$("div.topicfooter").remove();}
			 $("img[id^='TOGGLE']").parent("td").remove();
			 $("div#hmheadercontents").css("padding", "0 5px").prepend(manPrintButton);
			 $("div#hmheader, div#hmheader div").css({"border": "none", "height": "auto"});
			 $("html,body").css("background-color","#ffffff");
			 $("html").css({overflow: "auto"});
			 $("table,td,tr,th").css({"background": "none", "background-image": "none"});
			 $("#headerfirst").css ({"display": "table-header-group"});
			 $("#footend").css({"display": "table", "position": "static", "width": "100%"});
			 $("div#hmheader, div#idcontent").css({"position": "static", "overflow": "visible", "height": "auto", "border-width": "0"});
			 if (tVars.monoPrint) {
				 $("*").css({"color": "#000000"});
			 }
             $("div, table, tr, td, thead, tfoot, tbody").css("background-color", "transparent");
			 $('a, area').not(':has(> img.image-toggle)').attr({href: "javascript:void(0);", onclick: "void(0);"});
			 hmAnimate = temp;
			 $("body").css("visibility","visible").hide().slideDown("fast");
			// Only display the print dialog if it's been configured
			if (tVars.autoPrint) {
			// Multithreading browsers won't finish formatting the page correctly if you don't pause before calling print()
			setTimeout(function(){
				print();
				},300);
			}
		},150); // setTimeout
} // end doPrint()

// If target is a toggle open it
function openTargetToggle(target,context){
   var toggleTarget;
   var headToggle = false;
   if (context == "menu") { 
   	    // Only for ATOC menu
   		toggleTarget = $(target[0]).parent("span:has(a.dropdown-toggle)").find("a.dropdown-toggle").attr("href");
   		if (!toggleTarget) toggleTarget = $(target[0]).parent("p:has(a.dropdown-toggle)").find("a.dropdown-toggle").attr("href");
         } else {  // This is for all other toggleJump() functions
  	          // Check for target in a toggle header without an icon
   	         toggleTarget = $(target[0]).parent("p:has(a.dropdown-toggle)");
   	         toggleTarget = $(toggleTarget).find("a.dropdown-toggle").attr("href"); 
			 // if (toggleTarget) alert(toggleTarget);
       		 if (!toggleTarget) {
   	         // Check for target in a toggle header with an icon
				toggleTarget = $(target[0]).parent("td").parent("tr").parent().parent("table").parent("div:has(a.dropdown-toggle)");
  	   	        toggleTarget = $(toggleTarget).find("a.dropdown-toggle").attr("href");
   	          }  
		   }
   var iconToggle = false;
   var iconTarget = "";
   if (toggleTarget) {
   	    if (toggleTarget.indexOf("ICON") != -1) {
   	    	iconToggle = true;
   	    }
   		toggleTarget = toggleTarget.replace(/^.*?\,\'/, "");
   		toggleTarget = toggleTarget.replace(/\'.*$/,"");
		// alert("Processed ToggleTarget:  " + toggleTarget);
   		// if (iconToggle) iconTarget = "$" + toggleTarget + "_ICON";
		if (iconToggle) iconTarget = toggleTarget + "_ICON";
		// alert(toggleTarget + " : " + iconTarget);
   		if (!iconToggle ) {
   			HMToggle('expand',toggleTarget);
   			return true;
   			} else {
   				HMToggle('expand', toggleTarget, iconTarget);
   				return true;
   				} 
   		} else return false;

} // End openTargetToggle


function findPosY(obj)
{
    var curtop = 0;
    if (obj.offsetParent)
    {
        while (obj.offsetParent)
        {
            curtop += obj.offsetTop
            obj = obj.offsetParent;
        }
    }
    else if (obj.y)
        curtop += obj.y;
    return curtop;
}

// Flash an element on the page.
function flashTarget(obj,repeat,delay) {
	repeat--;
	doFlash();
	function doFlash() {
	setTimeout(function() {
	$(obj).each(function() {
		$(obj).css("visibility","hidden");
		setTimeout(function() {
			repeat--;
			$(obj).css("visibility","visible");
			if (repeat > 0) doFlash();
			},delay)
	});
	},delay);
} // doFlash;

} // flashTarget

function aniScroll(target, mode, tjump) {
	// var sTarget = tVars.header ? "div#idcontent" : "body";
	var sTarget = "div#idcontent";
		if (hmAnimate) {
			hmAnimate = false; 
			var switched = true; 
			}
   	var timer = toggleCheck(target[0]);
	if (timer > 400) timer = 400;
	openTargetToggle(target,mode);

	setTimeout(function(timer) {
		if (tjump) $(sTarget).scrollTo(0,0);
		// $("body").show();
		$("div#idcontent").css("visibility","visible");
		$(sTarget).scrollTo($(target), 600, { offset: -12, axis: "y",
			onAfter: function() {
				if (switched) {
				hmAnimate = true; 
				}
			if (!tjump) flashTarget($(target[0]).parent(),3,200);
			}
		});	
		},timer);
}	

// ToggleJump for links coming in from outside 
// This won't work with a jQuery load function in Firefox
// We need to preload an event listener to get it faster

function toggleJump() {
var jump = function() {
if (location.hash) {
  var theTargetID = location.hash.replace(/\#/, "");
  var theTarget;
 if ($("a[id='"+theTargetID+"']").length > 0) {
  	theTarget = $("a[id='"+theTargetID+"']");
  	   } else if ($("a[name='"+theTargetID+"']").length > 0) {
  	theTarget = $("a[name='"+theTargetID+"']");
  	   } else {
  	    return false;
  	    }
   	// If there are toggles on the page close them all
   	//if (HMToggles.length && HMToggles.length > 0 ) {
		// HMToggleExpandAll(false);
		//}
   aniScroll(theTarget,"page",true);
   return false;
    }
    } // jump()
 if (document.all && !window.opera) setTimeout(function() {
	 jump();
	 $("div#idcontent").css("visibility","visible");
	},20); else {
	jump();
	$("div#idcontent").css("visibility","visible");
	}
} // End function toggleJump()

// Toggle Toggler
function toggleToggles() {
var temp = hmAnimate;
if (HMToggles.length != null) {
	var toggleState = true;
	for (var i = 0; i < HMToggles.length; i++) {
		if (HMToggles[i].getAttribute("hm.state") == "1") {
			toggleState = false;
			break;
			}
		}
	if (HMToggles.length > 20 && temp) hmAnimate = false;
	HMToggleExpandAll(toggleState);
	hmAnimate = temp;
	}
} // End toggleToggles

function nsheader() {
	if (tVars.printMode) {return;}
// var hHeight = $("div#hmheader p")[0];
	if (tVars.header) {
	var maxHeight = 0;
	var topicOffset = 0;
	$("div#hmheader").children().each(function() {
		if ($(this).outerHeight() > maxHeight) maxHeight = $(this).outerHeight();
		});
	// hHeight = $(hHeight).outerHeight();
	// alert("Para height: " + hHeight + "\n" + "Max height: " + maxHeight);
        $("div#hmheader").css("height",(maxHeight+5)+"px");
	// topicOffset = (!window.opener && document.location.search.indexOf("toc=0") < 0) ? maxHeight+16 : maxHeight+16;
	topicOffset = maxHeight+16;
	$("div#idcontent").css("top",topicOffset+"px"); 
	} else {
	if (window.opener) {
	$("div#idcontent").css("top","2px");
	}
	}
}

/* Page Init */
$(document).ready(function(){
	
	// Hide page contents until everything is set up in main interface
	if (parent.window && parent.window.hmnavpages) {
		$("div#idcontent").css("visibility","hidden");
	} else if (/toc=0&printWindow/g.test(location.search)) {
		// If this is a printable page view do print and exit
		doPrint();
		return;
	}
	tVars.jumpdone = false;
	
	// Display the show TOC link if the page is opened on its own and it's not a print preview or EWriter
	if (self==top && !(window.opener && window.opener.hmWebHelp) && !hmForceRedirect && !tVars.printMode && !tVars.isEWriter) {
	loadScript("hm_webhelp_undocked.css","css");
	
	// Extract Zoom search highlight from URLs from external search pages and write to link for loading full UI
	var zoomrx = /(zoom_highlight(?:sub)?=.+)&|(zoom_highlight(?:sub)?=.+?)$/im;
	var match = zoomrx.exec(document.location.search);
	if (match != null) {
	var result = typeof match[1] != "undefined" ? match[1] : match[2];
	$('.sync-toc-link').attr('href',$('.sync-toc-link').attr('href') + "\&" + result);
	}
	
	// Tidy up
	$('.sync-toc').show();
	$('.sync-toc-off').hide();
	$('p#breadcrumbs a,p#breadcrumbs a:visited').css("color","red");
	$('p#breadcrumbs a:hover').css("color","blue");
	
	}
	
	// Unclicker DIV
	// $("body").prepend('<div id="unclicker"></div>');
	
	// Control the size of the non-scrolling header
	// Internet Explorer doesn't wait until the page is really loaded...
	if (document.all && !window.opera) {
	setTimeout(function() {
		nsheader();},
		0); } else {
		nsheader();
		}
	$(window).on("resize",function() {
	nsheader();
	});

// Include target for topic links to open them in main browser tab.
// Open all external links in an external window
var mainFrame = "hmcontent";
// Insane, but necessary to prevent script errors in brain-dead Internet Explorer:
if (document.all && window.opener && window.opener.hmWebHelp && !window.opera) {
	mainFrame = window.opener.frames[1].name;
	}
if (parent.window.hmWebHelp) {
if (window.name == mainFrame) {
	parent.hmWebHelp.mainDoc = document;
	parent.hmWebHelp.mainWin = window;
	parent.hmWebHelp.currentDoc = document;
	parent.hmWebHelp.currentWin = window;
} else {
	if (tVars.currP == parent.hmWebHelp.currentPage) {
		parent.hmWebHelp.currentDoc = document;
		parent.hmWebHelp.currentWin = window;
	}
	}
}

// Reference topic links to WebHelp UI in UI and undocked windows
if (parent.window.hmWebHelp || (window.opener && window.opener.hmWebHelp)) {
var textn = parent.window.hmWebHelp ? parent.window.hmWebHelp.textn : window.opener.hmWebHelp.textn;
// Remove the link reference from the tab in the undocked window
// if (window.opener) $("a#indextablink").removeAttr("href");

$("a[href*='\\"+textn+"'],area[href*='\\"+textn+"']").not("[href^='"+tVars.currP+"'],[href^='\\./"+tVars.currP+"'],[href^='\\.\\.'],[href^='\\./"+tVars.hmHelpPage+"'],[href^='"+tVars.hmHelpPage+"'],[href^='file:'],a.weblink").attr("target",mainFrame).on("click",function() {
	var target = $(this).attr("href");
	var remote = false;
	var tHash = target.substr(target.indexOf("#")+1);
	if (tHash.length > 0) {
	var tPlain = target.substr(0,target.indexOf("#"));
	if (parent.window.hmWebHelp) 
		remote = (tPlain == parent.hmWebHelp.currentPage && parent.hmWebHelp.tabsapi.getIndex() > 0);
	}
	 if (window.opener) {
		if (remote) window.opener.hmWebHelp.tabsapi.click(0);
		// IE no longer responds to links from the opened window targeting the frame ID in the opener
		// We need to load the target actively into the main window's main tab
		if (document.all && !window.opera) window.opener.$("iframe#"+mainFrame).attr("src",target);
		window.opener.hmWebHelp.tocWin.tocScroller(target);
		} 
		else {
		if (remote) parent.hmWebHelp.tabsapi.click(0);
		parent.hmWebHelp.tocWin.tocScroller(target);
		}
	});
 }
 
// Redirect all web links to a new page if configured
if (tVars.webRedirect) {
	$("a[href^='http\\:'], a[href^='https\\:'], a[href^='\\/\\/'], a.weblink, a.filelink").not("[class='xcSignupText']").attr("target","_blank");
}

// Set up internal links on page
// Target H&M-created links and manually-entered anchor links but not href="#" links
// Attach the click function to both normal links and image hotspots
$("a[href^='"+tVars.currP+"#'],a[href^='#']:not(a[href='#'],a[href='#disqus_thread']),area[href^='"+tVars.currP+"#'],area[href^='#']:not(area[href='#'])").click(function(event) {
   localLink=true;
   var localTargetID = $(this).attr("href").replace(/.*?\#/,"");
   var localTarget = $("a[id='"+localTargetID+"']");
   
   if (!localTarget.length > 0) localTarget = $("a[name='"+localTargetID+"']");
  aniScroll(localTarget,"page",false);
return false;
});

// Cachefix for links to topics within the project and breadcrumb links
if (parent.window && typeof parent.hmnavpages != "undefined" && parent.hmnavpages.cachefix) {
		$("a.topiclink, p#breadcrumbs a").on("click",function(event){
		event.preventDefault();
		if (parent.hmWebHelp.currentTabIndex === 0)
			document.location.href = parent.hmCacheFix.getTarget($(this).attr("href"));
		else
			parent.hmWebHelp.mainDoc.location.href = parent.hmCacheFix.getTarget($(this).attr("href"));
		});		
		} 
// Execute if topic is in the WebHelp UI, 
// otherwise it's an undocked window
if (parent.window.hmWebHelp) {
	function stagedInit() {

// Toggle Toggles button on/off
if (HMToggles.length && HMToggles.length > 0 ) {
	parent.hmWebHelp.enableTool("togtog",true);
} else {
parent.hmWebHelp.enableTool("togtog",false);
}

// Set up the toolbar in the main webhelp UI
   var nextP = window.tVars.nextP;
   var prevP = window.tVars.prevP;
   nextP = nextP != "" ? nextP : window.tVars.currP;
   prevP = prevP != "" ? prevP : window.tVars.currP;
   var linkRef = window.tVars.currP;
   linkRef = linkRef.substr(0,linkRef.lastIndexOf("."));

  // parent.window.hmWebHelp.tabsapi.getIndex();
   if (!parent.window.hmWebHelp.isNewTab) {
		parent.window.hmTabSlider.goToTab(0,true);
	   $("#navicon_next",parent.document).attr("href",nextP);
	   $("#navicon_previous",parent.document).attr("href",prevP);
	   $("#navicon_home",parent.document).attr("href",window.tVars.defP);
	   $("a#topictablink",parent.document).html(
		"<span>" + parent.window.hmWebHelp.clipTitle(window.tVars.titleP,window.tVars.cliptab) + "</span>"
		).attr(
		"data",parent.window.hmWebHelp.clipTitle(window.tVars.titleP,window.tVars.cliptitle)
		).attr(
		"title", parent.window.hmWebHelp.clipTitle(window.tVars.titleP,0)
		);
           } else {
           $("a#"+linkRef+"Link",parent.document).html("<span>" + parent.window.hmWebHelp.clipTitle(window.tVars.titleP,window.tVars.cliptab) + "</span>");
		   $("a#"+linkRef+"Link",parent.document).attr("data",parent.window.hmWebHelp.clipTitle(window.tVars.titleP,window.tVars.cliptitle));
           // parent.window.hmWebHelp.isNewTab = false;
           }
   // Update tabs slider
   parent.window.hmTabSlider.updateSlider();
   // Activate the new tab
	if (parent.window.hmWebHelp.isNewTab) {
		if (!parent.window.hmWebHelp.autoTabs) {
			parent.window.hmTabSlider.goToTab(3,true);
			}
		parent.window.hmWebHelp.isNewTab = false;
		}
	
	 // Select active tab if there is a specification in the URL
    if (parent.hmLayout.startTab > 0) {
	// Don't switch tabs until entire UI is properly built
	var doParseUrl = setInterval(function() {
	if (parent.hmWebHelp.hmWebHelpReady) {
		clearInterval(doParseUrl);
		if (parent.hmLayout.startTab == 1) parent.hmWebHelp.indexPane(); 
		else
		parent.hmWebHelp.searchPane();
		parent.hmLayout.startTab = 0;
	}
	},100);
	}  
	parent.window.hmWebHelp.hmTopicLoaded = true;
	} // stagedInit();

   } // End of webhelp UI routine
   else 
   // Routines for undocked windows and windows opened on their own
    {
	if (window.opener && window.opener.hmWebHelp && !tVars.printMode) {
	// var parentName = window.opener.name;
 
	// Close the undocked topic if the parent closes, reloads or goes elsewhere
	var closeCheck = setInterval(function(){
    function closeIt() {clearInterval(closeCheck); window.close();}
	try { var windowsOpen = window.opener.hmWebHelp.openWindows.length; 
		} catch(err) { closeIt();}	
		if(!window.opener || windowsOpen < 1) {
			closeIt();
			}
			},500);  
	// Remove link from tab
	$("a#indextablink").removeAttr("href");
	// Match skin to main window
	loadScript("hm_webhelp_undocked.css","css");
	$("body,html").css("backgroundImage", "url('"+tVars.background+"')");
	
	}
	
	
	} // Undocked/lonely window routines
	
// Setup ATOC

if ($("span[class*='_atoc_'], span[class*='_atocs_']").length >= hmatocvars.atoc_minHeaders && hmatocvars.atoc_show) {
$("div#atocIcon").css("visibility","visible");
tVars.jumpdone = true;	
if (/^https??:\/\//im.test(document.location)) {
$.getScript('autotoc.js', function(){
	autoTOC();
	// toggleJump();
});
} else {
	loadScript("autotoc.js","js");
	// Execute main function once script is fully loaded
	var loadAtoc = setInterval(function() {
		if (atocLoaded) {
		clearInterval(loadAtoc);
		autoTOC();
		// toggleJump();
			}
		},100);	
	}
}

// Code Sample Boxes

var	$copyCodeBoxes = $("span.f_CodeSampleLink");

if ($copyCodeBoxes.length > 0) {
	$copyCodeBoxes.on("click", function(event) {

	var $codeLink = $(event.target || event.srcElement), $codeLinkHTML = $codeLink.html(),
		$thisTable = $codeLink.parents("table").first(),
		$codeCell = $thisTable.find("td").first(),
		codeCell = $codeCell[0],
		range = document.createRange(),
		sel;
		
		
	range.setStartBefore(codeCell.firstChild);
	range.setEndAfter(codeCell.lastChild);

	sel = window.getSelection();
	sel.removeAllRanges();	
	sel.addRange(range);

	setTimeout(function(){
	
	try {  
		var successful = document.execCommand('copy');  
		
		if (successful) {
			sel.removeAllRanges();
			$codeLink.html("Kopiert!");
			
			setTimeout(function() {
				$codeLink.html($codeLinkHTML);
				},1000);
			}
		} catch(err) {  
			alert('Leider funktioniert die Zwischenablage mit diesem Browser nicht!'); 
			} 		
	},300);
	
	});
};

// Setup sortable tables

if ($("table[id*='_srt_']").length < 1) {
	tVars.tablesReady = true; } else
	{
	if (/^https??:\/\//im.test(document.location)) {
	$.getScript('sortable.js', function(){
	sortables_init();
	// if (doJump) toggleJump();
	});
	} else {
		loadScript("sortable.js","js");
		var loadSorter = setInterval(function() {
		if (sortableLoaded) {
		clearInterval(loadSorter);
		sortables_init();
		// if (doJump) toggleJump();
			}
		},100);	
		}
}

// Do toggleJump or scroll to search result when the whole page is ready 

(function(){
	var togglesStart, togglesCount;
	// var target = SearchCheck();
	var hashCheck = document.location.hash;
	var cycles = 0;
	togglesStart = togglesCount = HMToggles.length;
	var doJump = setInterval(function() {
		togglesCount = HMToggles.length;
		cycles++;
		if (togglesCount > togglesStart) {
			togglesStart = togglesCount;
			} else {
			tVars.togglesReady = true;
			}
		if (tVars.togglesReady && tVars.tablesReady) {
			clearInterval(doJump);
			$("div#idcontent").css("visibility","visible");
			if (parent.hmWebHelp) {
				parent.hmWebHelp.newTabReady = true;
				if (typeof stagedInit == "function") stagedInit();
				}
		// Is there an anchor to jump to?
			if (hashCheck && hashCheck.length > 0) {

			toggleJump();
			} 
		}
	},200); // End of doJump interval
})(); 

// Social sharing function
hmSharePage = function(target) {
	var title = document.title,
		url = parent.document.location.href;

	switch(target) {
		case 'facebook':
			window.open('https://www.facebook.com/sharer.php?u=' + encodeURI(url), '_blank');
			break;
		case 'twitter':
			window.open('https://twitter.com/intent/tweet/?url=' + encodeURI(url) + '&text=' + encodeURIComponent(title) + ": ", '_blank');
			break;
		case 'linkedin':
			window.open('https://www.linkedin.com/shareArticle?mini=true&url=' + encodeURI(url) + '&title=' + encodeURIComponent(title), '_blank');
			break;
		case 'email':
			window.location.href = 'mailto:?subject=' + encodeURIComponent(title) + '&body=' + encodeURI(url);
			break;
	}
};

$(window).on("hashchange", function() {
	if (parent.window && parent.window.hmnavpages) {
		$("div#idcontent").css("visibility","hidden");
	}
	setTimeout(function() {
		toggleJump();
		},300);
	});

});
